/*
    
    Ec     Copyright (C)   2001 Marc Dechico

    ec_eva.c :  compute the datas collected during the simulation 
                (exploration of the game tree) 
		automat to find bugs in the engine (play random)
		automat to compare methode of evaluation 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: ec@dechico.com 
    
*/
#include "ec_eva.h"
/************************************************************************/
/* external function */
/************************************************************************/
/* simu */
extern int  simul_eva       (int i_pro_sim_niv_wrk,	         /* simulation pour evaluation meilleur mvt */
			     int i_pro_sim_inc_wrk);

extern void aff_cal_en_cou  (int i_not_cpt_mvt_ini);
extern void aff_mes_uti     (int i_mes_num);
extern void sto_sim 	    (void);		/* Stop simulation  */
extern int  simul           (int i_pro_sim_niv_wrk,	/* retourne meilleur mouvement */
		             int i_pro_sim_inc_wrk	);
extern void 	ini_pgm      (void);/* ec_ini */

/* ec_jou*/
extern  int jou	           (int i_pos_dep_n,  		/* joue avec coordonnes reelles */	 
		            int i_pos_arr_n,
		            char c_rem_pio	);
extern  int simul_ctl       (void);			         /* simulation pour controle mat/pat */

extern void ann_cou 	    (void);			/* annule coup */
extern int  sav_dsk         (char tc_nom_fic[40]);
extern char pro_pio_tra_tmvt_tpie (int i_typ_mvt);     /* traduit type mvt en type  piece*/
extern char pro_pio_tra_tmvt_lpie (int i_typ_mvt);    /* traduit type mvt en type  piece*/

//extern int add_mvt_l1(struct st_hash  *pst_hash ,
//	       int i_dep, int i_arr, int i_typ_mvt); 
//extern int add_mvt_l2(struct st_hash  *pst_hash ,
//	       int i_dep, int i_arr,int i_typ_mvt); 
extern int sim_add_l3(struct st_hash *pst_hash);
extern int sim_add_l2(struct st_hash *pst_hash);
extern int sim_add_l1(struct st_hash *pst_hash);

/************************************************************************/ 
/* external datas */
/************************************************************************/
/* tableau pointant sur pièce camp 0 ou 1 */
extern struct st_pie *tpts_pie[2];		/* tableau pointant sur pièce camp 0 ou 1 */
                                                /* poste 0 camp 0, 1 camp 1 */

extern struct st_ech ts_ech[100];               /* tableau echiquier accès par l'emplacement  */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];  /* tableau historique des coups */
extern defv_bool defv_aff_not_pos;                  /* =1 si affichage note possible */
extern defv_bool defv_aff_cal_cou;		        /* = 1 si affichage calcul en cour */
extern int i_pro_act;                           /* profondeur actuelle	*/
extern int i_pro_sim_niv;			/* niveau de simulation */
extern int i_pro_sim_inc;			/* nivde simu pour incrmen*/
extern int i_pro_sim_act;             		/* profondeur de simulation 		*/
extern int i_pro_sim_max_sup;         		/* profondeur maximale superieur 	*/
extern int i_pro_sim_max_inf;         		/* profondeur maximale inferieur	*/
extern int i_not_cpt_mvt_ini;			/* note: compteur mvt initial 		*/
extern struct st_hst_pro	*pts_hst_pro; 	/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro_p; /* ptr sur tableau structure historique  */
extern struct st_pie  		*pts_pie;      	/* ptr sur tbl structure pièce principale*/


/************************************************************************/
/* inernal datas */
/************************************************************************/

/* Sous Structure  not_mvt_ini pour evaluation mat/pat par profondeur */
struct  st_hst_pro_sta tst_pro_sta[MVT_INI][PRO_SIM_INF_MAX]; 

/* tableau note du mvt initial */
ST_NOT_MVT_INI  ts_not_mvt_ini[MVT_INI] ;

/* indexe pour retrier les mouvement */
struct st_tri_mvt_ini  ts_tri_mvt_ini [MVT_INI];
/* structure pour evaluation rapport de force */
struct st_eva_sit  st_eva_sit ;

int (*pf_eva) (void);  			/* pointeur sur fonction évaluation */
int (*tpf_eva[100]) (void);  		/* tableau pointeur sur fonction évaluation */
static struct st_pos tst_pos [PRO_HST];


/*******************************************************************************/
/* local functions  */
/*******************************************************************************/

int sim_jou(void);                              /* simul et joue  */
static void ini_pos (int i_pro);		/* init du trait */
static void sav_pos_pie (int i_pro, int i_cam);	/* sauvegarde du trait piece d'un camp */
void sav_pos (int i_pro);			/* sauvegarde du trait */
int ctl_rep_pos (int i_pro);			/* controle si trait se reproduit */		
static int  ctl_rep_pos_pie (int i_pro_act, int i_pro);/* controle complet toutes pieces */ 

 int 	eva_mei_mvt	(void);	      	 	/* retourne meilleur mouvement */
 int 	eva_mei_mvt_01	(void);		       	/* retourne meilleur mouvement */
 int 	eva_mei_mvt_02	(void);		       	/* retourne meilleur mouvement */
static int eva_mei_mvt_test(void);		       	/* retourne mouvement aux hasard */

 void 	not_mvt_ini_raz	(int i_pro_sim,		/* raz de la structure note mvt ini  avant simulation */
			 int i_inc_pro_sim);			
void	hst_cpt_raz (defv_bool defv_bool_hash);/* init nbre de coup par niveaux */
void 	not_cal (void);			/* calcule et mémorisation de la note du mvt initial */
static  void tra_don (void);
static void cal_cou_rep (ST_NOT_MVT_INI *pts_mvt);/* calcul couverture */

float 	eva_cou_cam (int nn);		/* analyse de la couverture */
static float eva_cou_pie 	(int nn,int i_cam);	/* analyse de la couverture par piece*/

static void cal_mob 	(			/* calcul mobilite */
			 ST_NOT_MVT_INI *pts_mvt
			 );

static void 	cum_not_pon 	(			/* cumul note pondéré*/
			 enum  typ_not e_typ_not ,
			 ST_NOT_MVT_INI *pts_mvt
			 );
static void 	cum_not 	(			/* cumul note sans pondéré*/
			 enum typ_not e_typ_not,
			 ST_NOT_MVT_INI *pts_mvt
			 );

static void 	cal_dif_max 	(			/* Calcul difference pc-ca et min max*/
			 enum typ_not e_typ_not,
			 ST_NOT_MVT_INI *pts_mvt 
			 );
static void 	cal_max 	(			/* Calcul min max*/
			 enum typ_not e_typ_not,
			 ST_NOT_MVT_INI *pts_mvt 
			 );

static void 	rec_not_mvt 	(enum typ_not e_typ_not);/* recadrage de la note en fonction des mini maxi */
static int 	rec_not		(float min, float max,	 /* Recadrage note */
			       float val);
static void 	pon_not		(void);			/* Pondération note */

static void 	cho_coe_01 	(void);			/* Choix coeficient */
static void 	cho_coe_02 	(void);			/* Choix coeficient */
static int 	eva_for_cam	(int i_cam);            /* retourne  force du camp */
static void 	eva_sit		(int i_cam,int i_cam_adv);
static int 	ctl_ega		(void);			/* controle si égalité doit être évitée */


/* make the engine work alone in order to meet a bug like king taken! */ 
 void  	sim_aut 	(void);			/* pour faire jouer automatiquement */
 void  	test_aut 	(void);			/* pour techercher d'éventuel bugs  */
static int 	jou_par_aut	(int i_mvt_ini);	/* joue une partie automatiquement */ 
static void  	tri_mvt_rec 	(void);			/* tri des mvt initial par ordre decroissant not_rec*/

/* printing and debugging functions */
void aff_pie       (int i_cam);
void aff_pie_lin   (int i_pie,struct st_pie *ptst_pie);
void aff_hst_wra   (int i_pro_deb, int i_pro_fin);
void aff_hst       (int i_pro_deb, int i_pro_fin);
int  aff_not_1     (int *pi_mei_mvt);
int  aff_not_2     (int *pi_mei_mvt);
void aff_nex_pag   ();
void aff_pre_pag   ();
int aff_mvt_ini    (int i_mvt_ini);
void aff_cal_en_cou(int i_not_cpt_mvt_ini);
static void for_nul_sci_nbr (char *str);  
static void print_sci_nbr (float f_nbr);
extern int      ver_aff_not_pos (void);                         /* verifie  si affichage note possible */
extern int      ver_exi_mvt_ini (int i_mvt_ini);                /* verifie existance mvt ini */

/*printing stat */
/* Libelle des type de note */
struct { char *label;}
 lib_typ_not []=
{
  { N_("   Mvt_Nbr") },
  { N_("   Mat_Nbr") },
  { N_(" IcMat_Nbr") },
  { N_("   Sta_Nbr") },
  { N_(" IcSta_Nbr") },
  { N_(" RfMat_Nbr") },
  { N_(" RfSta_Nbr") },
  { N_("  Fork_Nbr") },
  { N_("   Pie_Mob") },
  { N_("   Pie_Cov") },
};

/* Separateur*/
/* bug find a way to declare it static without a warning messge */

char tc_sep_tir_120[]="\n-----------------------------------------------------------------------------------------------------------------------";
char tc_sep_tir[]="\n-------------------------------------------------------------------------------";


/************************************************************************/
/* function */
/************************************************************************/
/* simul et joue  */
int sim_jou(void)
{
  int i_msg;
  /* org essayer de ne pas faire référence à ts_not_mvt_ini */ 
  i_msg=simul_eva(i_pro_sim_niv,i_pro_sim_inc); /* recherche du meilleur mouvement */
  if (i_msg>=0) /* si pas deja mat ou pat */
    {
      i_msg=jou(
		ts_not_mvt_ini[i_msg].i_pos_ori_n,
		ts_not_mvt_ini[i_msg].i_pos_arr_n,
		pro_pio_tra_tmvt_tpie(ts_not_mvt_ini[i_msg].i_typ_mvt)
		);
 
      if ( i_msg ==0 ) /* si pas d'erreur pendant mouvement toujours vrai!?*/
	{	i_msg=simul_ctl();  /* controle si mat pat */
	sav_dsk("ec.wrk");
	} 
    }

  return i_msg;

}

void cho_coe_01 (void)
{
  
  st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

  st_eva_sit.ti_coe_pon[nbr_mat]		=5;
  st_eva_sit.ti_coe_pon[nbr_mat_rf]		=10;
  st_eva_sit.ti_coe_pon[nbr_mat_inc]		=1;

  if (st_eva_sit.i_not_for < -230)
    {
      st_eva_sit.ti_coe_pon[nbr_pat]		=7;
      st_eva_sit.ti_coe_pon[nbr_pat_rf]		=15;
      st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
    }
  else
  {
      st_eva_sit.ti_coe_pon[nbr_pat]		=0;
      st_eva_sit.ti_coe_pon[nbr_pat_rf]		=0;
      st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
  }
  st_eva_sit.ti_coe_pon[mob_pie]		=3;
  st_eva_sit.ti_coe_pon[cou_pie]		=3;
  st_eva_sit.ti_coe_pon[nbr_fou]		=3;

}
void cho_coe_02 (void)
{
  /*pourrait calculer directement coef à partir note situation */ 
  /* il faudrait mouliner et faire des statistiques pour vérifier */
  /* la véracité  des coef choisis */

  /* pour qu'une note soit prepodérante il faut que sont coef soit 
     superieur à la somme des coef des autre notes                */
  
  st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat]		=3;
  st_eva_sit.ti_coe_pon[nbr_pat]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat_rf]		=3;
  st_eva_sit.ti_coe_pon[nbr_pat_rf]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat_inc]		=2;
  st_eva_sit.ti_coe_pon[nbr_pat_inc]		=0;
  st_eva_sit.ti_coe_pon[mob_pie]		=1;
  st_eva_sit.ti_coe_pon[cou_pie]		=0;
  st_eva_sit.ti_coe_pon[nbr_fou]		=0;

}
int  eva_mei_mvt(void)
{
  int i_mei_mvt;

  i_mei_mvt= (*pf_eva)();

  return i_mei_mvt;
}

int  eva_mei_mvt_01(void)
{	
  /* traitement des donneés */
  tra_don ();

  /* Choix coef de ondération */
  cho_coe_01();

  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega();

}

int  eva_mei_mvt_02(void)
{	
   /* traitement des donneés */
  tra_don ();

  /* Choix coef de ondération */
  cho_coe_02();

  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega();

}
int  eva_mei_mvt_test(void)
{
  /* pour detecter d'évantuels bugs */ 
  /* le traitement est le même sauf que je choisi un mvt au hasard au lieu 
     de celui considré comme le meilleur */  

  int mvt_ini;
  double d_rand;
   /* traitement des donneés */
  tra_don ();

  /* Choix coef de ondération */
  cho_coe_02();

  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* retourne un mvt initial pris au hasard...  */
  d_rand=rand();   /* remplace random() pour compatibilité BORLAND */
  mvt_ini= (unsigned int)(i_not_cpt_mvt_ini *d_rand/RAND_MAX);
  return mvt_ini;

}
void not_mvt_ini_raz(int i_pro_sim,int i_inc_pro_sim)
{
  int x,y;

  ST_NOT_MVT_INI *pts_mvt;

  enum typ_not tn;
  for(x=0;x<MVT_INI;x++)
    {
      pts_mvt = &ts_not_mvt_ini[x];
      /* org : shouldn't refer to hst */
      pts_mvt->i_cam		=pts_hst_pro->i_cam;
      pts_mvt->i_cam_adv	=pts_hst_pro->i_cam_adv;
      pts_mvt->i_pro_sim	=i_pro_sim;
      pts_mvt->i_inc_pro_sim	=i_inc_pro_sim;
      
      for(y=0; y<PRO_SIM_INF_MAX; y++)
      for (tn = 0; tn <NBR_TYP_NOT;tn++)
	{
	  /* remise a zero des cumuls provenant de hst et autres*/
	  pts_mvt->tst_not[tn].f_not_cam_bru[BLANC]=0;
	  pts_mvt->tst_not[tn].f_not_cam_bru[NOIR]=0;
	  pts_mvt->tst_not[tn].f_not_cam_pon[BLANC]=0;
	  pts_mvt->tst_not[tn].f_not_cam_pon[NOIR]=0;
	  pts_mvt->tst_not[tn].f_not_dif_pon=0;
	  pts_mvt->tst_not[tn].i_not_pon_rec=0;
	}

 	{
	  /* Remise à zero des infos collecté dans hst  pro*/
	  tst_pro_sta[x][y].i_cam=0;
	  tst_pro_sta[x][y].i_inc=0;
	  for (tn = 0; tn <NBR_TYP_NOT;tn++)
	    tst_pro_sta[x][y].f_dat_pro[tn]=0;

	}
    }
  /* raz valeur d'évaluation de la situation */
  st_eva_sit.ti_tot_for	[BLANC]	=0;
  st_eva_sit.ti_tot_for	[NOIR ]	=0;
  st_eva_sit.i_not_for		=0;

  st_eva_sit.tf_cou	[BLANC]	=0;
  st_eva_sit.tf_cou	[NOIR ]	=0;
  st_eva_sit.f_cou		=0;
  
  st_eva_sit.tf_mob	[BLANC]	=0;
  st_eva_sit.tf_mob	[NOIR ]	=0;
  st_eva_sit.f_not_mob		=0;
 
  for (tn = 0; tn <NBR_TYP_NOT;tn++)
    {
      st_eva_sit.ti_coe_pon[tn]		=0;
      st_eva_sit.tst_int_not[tn].max 	=0;
      st_eva_sit.tst_int_not[tn].min 	=0;
    }
}
void hst_cpt_raz(defv_bool defv_bool_hash)
{
  int pro;
  int i_dec;
  defv_bool defv_ene;
  /* opti: commencer à profondeur  actuelle */
   for(pro=i_pro_act+1;pro <= i_pro_sim_max_inf;pro++)
    {
      ts_hst_pro[pro].uli_cpt_mat	  =0;
      ts_hst_pro[pro].uli_cpt_pat	  =0;
      ts_hst_pro[pro].uli_cpt_mat_rf	  =0;
      ts_hst_pro[pro].uli_cpt_pat_rf	  =0;
      ts_hst_pro[pro].uli_nbr_fou	  =0;
      ts_hst_pro[pro].uli_cpt_cou  	  =0;
#ifdef STHASH1
      ts_hst_pro[pro].i_nbr_ele_tpf_hash =-1; 
      ts_hst_pro[pro].i_mem_hash_nbr     =-1;
      ts_hst_pro[pro].i_sto_res_hash_nbr =-1;
#endif
    }

  /* precalculation du rapport de force initial */
  /* pour eviter un accés tableau par le camp */ 
  /* rapport de force camp 0 = - rap de for camp 1 */
  /* opti : recalculé en fin de simu pour evaluation */

   /*
     i_big_adv 
    =
    eva_for_cam(ts_hst_pro[i_pro_act+1].i_cam)
    -
    eva_for_cam(ts_hst_pro[i_pro_act+1].i_cam_adv)
    - FOR_FOU 
    - FOR_TOU;
   */
  /* pour savoir si le camp en cours est l'adversaire dans la simulation  */
  defv_ene = N;
  i_dec=0;
  for (pro=i_pro_act+1;pro <= i_pro_sim_max_inf;pro++)   
    {
      /* qui est l'enemie */
      ts_hst_pro[pro].defv_ene = defv_ene;
      if(defv_ene == Y)
	defv_ene = N;
      else
	defv_ene = Y;
      /* mise à jour du décrement de la note.
	 Plus le mat est proche de la base, moins la note mat sera  forte */
      ts_hst_pro[pro].i_dec_mat  = 10 * ++i_dec;
#ifdef STHASH
      ts_hst_pro[pro].pf_hash_add_lx = NULL;
#endif      
    }
  if(defv_bool_hash)
    {
#ifdef STHASH
      ts_hst_pro[i_pro_act +1].pf_hash_add_lx = sim_add_l1;/*deprecated */
      ts_hst_pro[i_pro_act +2].pf_hash_add_lx = sim_add_l2;
      ts_hst_pro[i_pro_act +3].pf_hash_add_lx = sim_add_l3;
#endif
#ifdef STHASH1
      /* detemine the number of hash to use*/
      int i_depth=i_pro_sim_max_sup - i_pro_act;
      int i_inc=i_pro_sim_max_inf - i_pro_sim_max_sup;
      int i_nbr_hash=0;
      printf("\nhst_init:depth %i inc %i",i_depth,i_inc);
      switch (i_depth)
	{
	case 3:
	  if (i_inc >=2){ i_nbr_hash=1; }
	  break;
	case 4:
	  if (i_inc >=2) i_nbr_hash=2; else i_nbr_hash=1;
	  break;
	case 5:
	  if (i_inc >=2) i_nbr_hash=3; else i_nbr_hash=2;
	  break;
	case 6:
	  if (i_inc >=2) i_nbr_hash=4; else i_nbr_hash=3;
	  break;

	}
      if (i_nbr_hash >= NBR_MAX_HASH) i_nbr_hash=NBR_MAX_HASH-1;

      

      int i;
      for (i=0;i<i_nbr_hash;i++)
	{
	 
	  int x=i_pro_act +i;
	  int y;

	  y=++(ts_hst_pro[x+1].i_nbr_ele_tpf_hash); 
	  ts_hst_pro    [x+1].ti_arg_fct_hash_add[y]=i;
	  ts_hst_pro    [x+1].tpf_hash_add[y]=sim_add_l1;
	  ts_hst_pro    [x+1].i_mem_hash_nbr=i;

	  y=++(ts_hst_pro[x+2].i_nbr_ele_tpf_hash); 
	  ts_hst_pro    [x+2].ti_arg_fct_hash_add[y]=i;
	  ts_hst_pro    [x+2].tpf_hash_add[y]=sim_add_l2;

	  y=++(ts_hst_pro[x+3].i_nbr_ele_tpf_hash); 
	  ts_hst_pro    [x+3].ti_arg_fct_hash_add[y]=i;
	  ts_hst_pro    [x+3].tpf_hash_add[y]=sim_add_l3;

	  ts_hst_pro    [x+4].i_sto_res_hash_nbr=i;

	} 

#endif      

    }
}


void not_cal (void)
{
  /* Stockage des données dans structure du mvt initial                     */

  struct st_pie		*pts_pie_cal;	/* ptr tableau struct pièce */
  ST_NOT_MVT_INI *pts_mvt;
   int x,y; 				/* index pour transfert de nbr coups */
  /* de hst dans not mvt ini */ 
  int inc;
  pts_mvt = &ts_not_mvt_ini[i_not_cpt_mvt_ini];
   
  /* memorise le numéro de mvt */
  pts_mvt->i_num_mvt =i_not_cpt_mvt_ini;

  /* memorise l'Id */
  pts_mvt->i_Id = pts_hst_pro_p->i_Id;

  /* memorise le type du mouvement */
  pts_mvt->i_typ_mvt =  pts_hst_pro_p->i_typ_mvt;
  
  /* memorise la position de depart */
  pts_mvt->i_pos_ori_n = pts_hst_pro_p->i_pos_ori_n;

  /* memorise la position d'arrivée */
  pts_mvt->i_pos_arr_n =  pts_hst_pro_p->i_pos_n;
  
  /* initialisation des pionteurs sur  pie */
  pts_pie_cal = pts_hst_pro_p->pts_pie_pc + pts_hst_pro_p->i_Id;

  /* memorise le libelle */
  pts_mvt->c_lib_pie = pts_pie_cal->c_lib_pie;

  /* memorise de la note  */
  pts_mvt->i_not_pri = pts_hst_pro_p->i_not ;

  /* Stockage des infos de hst dans mvt ini pour retraitement ulterieur */
  for(x=i_pro_sim_act,y=0; x<=i_pro_sim_max_inf; x++,y++)
    {
      /* Memorisation du camp */
      tst_pro_sta[i_not_cpt_mvt_ini][y].i_cam =ts_hst_pro[x].i_cam;
		
      /* Memorisation si increment  */
      if  (x>i_pro_sim_max_sup)
	inc=1;
      else
	inc =0;
      tst_pro_sta[i_not_cpt_mvt_ini][y].i_inc = inc;

      /* transfert nombre de mvt */
 
       tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mvt] 		
	=
	ts_hst_pro[x].uli_cpt_cou;

      ts_hst_pro[x].uli_cpt_cou = 0;
		
      /* transfert npmbre de mat */

      if(inc == 0)	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_mat;
      else	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat_inc] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_mat;

      ts_hst_pro[x].uli_cpt_mat = 0;
		
      /* transfert npmbre de pat */
      if(inc == 0 )	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat;
      else
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat_inc] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat;

      ts_hst_pro[x].uli_cpt_pat = 0;
	
      /* transfert npmbre de mat raport de force >=0 */

      if(inc == 0 )	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat_rf] 	 		
	  =	
	  ts_hst_pro[x].uli_cpt_mat_rf;

      ts_hst_pro[x].uli_cpt_mat_rf = 0;
		
      /* transfert npmbre de pat rapoort de force >=0 */
      if(inc == 0)	 
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat_rf] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat_rf;
      ts_hst_pro[x].uli_cpt_pat_rf = 0;

      /* transfert nombre de fourchette  */
		if(inc == 0)
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_fou] 	 		
	  =
	  ts_hst_pro[x].uli_nbr_fou;
      ts_hst_pro[x].uli_nbr_fou  = 0;
	
    }
 
  if	(
	 i_pro_sim_max_sup!= i_pro_act+2
	 ||
	 i_pro_sim_max_inf!= i_pro_act+2
	 )
    {
    aff_cal_en_cou(i_not_cpt_mvt_ini);
  /*test*/
    /*aff_ech(0);aff_pie(0);*/

    }
  
  /* interuption de la simulation si mat detecté */
  if (pts_hst_pro_p->defv_mat == Y) sto_sim();

  /* increment du compteur de mouvement */
  i_not_cpt_mvt_ini++;

}


void tra_don (void)
{
  /* Traitement des donnes pour evaluation du meilleur coup */
  int cpt_mvt;
  enum typ_not  cpt_typ_not;
  int i_cam;
  int i_cam_adv;
  ST_NOT_MVT_INI *pts_mvt;

  i_cam 	=ts_hst_pro[i_pro_act+1].i_cam;
  i_cam_adv 	=ts_hst_pro[i_pro_act+1].i_cam_adv;

  /* évaluation de la situation */
  eva_sit(i_cam,i_cam_adv);
	

  /* traitement des données collectées dans hst */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];


      /* cumule valeurs  profondeur	  	*/
      /* calcul différence pc - ca		*/
      /* memorisation mini maxi     		*/
      
      /*dans ce cas seulement  ne pondere pas le nombre de mvt par lui même */
      cum_not(nbr_mvt,pts_mvt);
      
      cum_not_pon(nbr_mat,pts_mvt);
      cum_not_pon(nbr_mat_inc,pts_mvt);
      cum_not_pon(nbr_pat,pts_mvt);
      cum_not_pon(nbr_pat_inc,pts_mvt);
      cum_not_pon(nbr_mat_rf,pts_mvt);
      cum_not_pon(nbr_pat_rf,pts_mvt);
      cum_not_pon(nbr_fou,pts_mvt);
      
      /* calcul couverture et répétition situation  */
      cal_cou_rep(pts_mvt);
		
      /* clacul de la mobilité */
      cal_mob(pts_mvt);     
 

    } /* fin de la boucle cpt mvt initial */

  /* calcul des notes recadrées */
  for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
    {
      rec_not_mvt(cpt_typ_not);
    }
}
void cal_cou_rep (ST_NOT_MVT_INI *pts_mvt)
{
/* calcul de la couverture et répétitin situation */
  int i_msg;

  /* deplace la piece */
  i_msg = jou (
       pts_mvt->i_pos_ori_n,
       pts_mvt->i_pos_arr_n,
       pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt)
       ) ;
  if(i_msg<0)
    { 	
      printf("\n%c:",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      aff_mes_uti(i_msg);
      return;
    }
  else
    {   
 
      /* sauvegarde du nombre de répétition de situation d'echiquier */
      pts_mvt->i_nbr_rep_sit  = ctl_rep_pos(i_pro_act);
   	
      /* calcul couverture */
      pts_mvt->tst_not[cou_pie].f_not_cam_pon[BLANC] = eva_cou_cam(BLANC);
      pts_mvt->tst_not[cou_pie].f_not_cam_pon[NOIR ] = eva_cou_cam(NOIR );
      cal_dif_max(cou_pie,pts_mvt);

      /*restore la piece */ 
      ann_cou();
    }
  return;
}
void cal_mob (ST_NOT_MVT_INI *pts_mvt)
{
  float mob1,mob2;
  /* calcul de la mobilité par camp */
  
 
  mob1= tst_pro_sta[pts_mvt->i_num_mvt][0].f_dat_pro[nbr_mvt];
  if ( mob1 != 0)
    mob2 =  tst_pro_sta[pts_mvt->i_num_mvt][1].f_dat_pro[nbr_mvt]
      / 
      mob1;
                                          
  else 
    mob2 =0;

  pts_mvt->tst_not[mob_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][0].i_cam]
    = mob1;
  pts_mvt->tst_not[mob_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][1].i_cam]
    = mob2;

  cal_dif_max(mob_pie,pts_mvt);

}

void cum_not_pon (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)
{
  /* org: revoir nom de fonction */
  /* retraite info provenant de hst_pro et cal différence camp -camp adverse
     zt aussi mise à jour des maxi mini */
  int i_cpt_pro;
  float f_pon;
  int i_cam;
  float f_nbr_mvt;

  /* Raz des cumuls */
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[NOIR ]=0;

   pts_mvt->tst_not[e_typ_not].f_not_cam_bru[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_bru[NOIR ]=0;
  
  for(i_cpt_pro=0;i_cpt_pro <PRO_SIM_INF_MAX; i_cpt_pro++)
    {
      /* Cumul par camp  des données stocké par profondeur  en pondérant
       avec le nombre de mvts de la pronfondeur d'acquisition */
      f_nbr_mvt =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[nbr_mvt];
      if(f_nbr_mvt != 0)
	f_pon =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not]
	  / f_nbr_mvt;
      else
	f_pon=0;

      i_cam =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].i_cam;
      pts_mvt->tst_not[e_typ_not].f_not_cam_pon[i_cam]+=f_pon;

      /* Cumul par camp  des données stocké par profondeur sans pondérer */
      pts_mvt->tst_not[e_typ_not].f_not_cam_bru[i_cam]+=
	 tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not];
    }
  
  cal_dif_max(e_typ_not,pts_mvt);

}
void cum_not (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* retraite info provenant de hst_pro et cal différence camp -camp adverse
     zt aussi mise à jour des maxi mini */
  int i_cpt_pro;
  int i_cam;

  /* Raz des cumuls */
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[NOIR ]=0;
  
  /* Cumul par camp  des données stocké par profondeur  en pondérant */
  for(i_cpt_pro=0;i_cpt_pro < PRO_SIM_INF_MAX; i_cpt_pro++)
    {

      i_cam =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].i_cam;
      pts_mvt->tst_not[e_typ_not].f_not_cam_pon[i_cam]+=
	 tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not];

    }
  
  cal_dif_max(e_typ_not,pts_mvt);

}

void cal_dif_max (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* Calcul de la difference camp propre  - camp adverse  et mise à jour des maxis */

  /* Calcul de la différence */
  pts_mvt->tst_not[e_typ_not].f_not_dif_pon=
    pts_mvt->tst_not[e_typ_not].f_not_cam_pon[pts_mvt->i_cam]
    -
    pts_mvt->tst_not[e_typ_not].f_not_cam_pon[pts_mvt->i_cam_adv];
  
  /* Mise à jour des maxi mini */
  cal_max(e_typ_not,pts_mvt);

}
void cal_max (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* Mise à jour des maxi mini */
  if ( pts_mvt->tst_not[e_typ_not].f_not_dif_pon > st_eva_sit.tst_int_not[e_typ_not].max)
    st_eva_sit.tst_int_not[e_typ_not].max=  pts_mvt->tst_not[e_typ_not].f_not_dif_pon;    

  if ( pts_mvt->tst_not[e_typ_not].f_not_dif_pon < st_eva_sit.tst_int_not[e_typ_not].min)
    st_eva_sit.tst_int_not[e_typ_not].min=  pts_mvt->tst_not[e_typ_not].f_not_dif_pon;    


}

void rec_not_mvt (enum typ_not e_typ_not)
{
  /* recadrage de la note en fonction des mini maxi */
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;

  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
		pts_mvt = &ts_not_mvt_ini[cpt_mvt];

      pts_mvt->tst_not[e_typ_not].i_not_pon_rec 
	=
	rec_not(  st_eva_sit.tst_int_not[e_typ_not].max,
		  st_eva_sit.tst_int_not[e_typ_not].min,
		  pts_mvt->tst_not[e_typ_not].f_not_dif_pon);
 
    }

}
/* recadrage note */ 
int rec_not (float max,float min, float val)
{
  float x = 0;
  x = max-min;
  if (x == 0)
    return 0;
  else
    return (int) ((val-min)/x*100);

}
void  tri_mvt_rec (void)
{
  /* tri en ordre decroissant des mvt selon total recadrée pondéré */
  int cpt_1,cpt_2;
 ST_NOT_MVT_INI *pts_mvt;

  /* chargement table d'indexe avec adresse mvt */
  for (cpt_1 = 0; cpt_1 < MVT_INI; cpt_1++)
	 {
		if (cpt_1 < i_not_cpt_mvt_ini)
	/* pointeur sur mouvement courant*/
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = &ts_not_mvt_ini[cpt_1];
      else
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = NULL;

	 }
  /* tri décroissant  des mvt avec note recadrée pondérée totale */ 
   for (cpt_1 = 0; cpt_1 < i_not_cpt_mvt_ini; cpt_1++)
	 {
      for (cpt_2 = cpt_1+1; cpt_2 < i_not_cpt_mvt_ini; cpt_2++)
	{
	  if(
	     ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	     <
	     ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	     ||
	     (
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	      ==
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	      &&
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->f_tot_rec_pon 
	      <
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->f_tot_rec_pon
	      ) 
	     )
	    {
	      pts_mvt= ts_tri_mvt_ini[cpt_2].pts_tri_rec;
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec=ts_tri_mvt_ini[cpt_1].pts_tri_rec;
			ts_tri_mvt_ini[cpt_1].pts_tri_rec=pts_mvt;
		 }
	}
    }
}

void pon_not(void)
{
  /* org: nom mal choisi car confusion avec pondération par nbr mvt 
     dans ce cas on pondere avec coeficiant */
  int cpt_mvt;
 ST_NOT_MVT_INI *pts_mvt;

  int pon_tot	=0;
  float tot_rec	=0;
  float tot_dif	=0;
  int cpt_typ_not;

  /* cumul des coeficient */
  for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
	 pon_tot+=st_eva_sit.ti_coe_pon[cpt_typ_not] ;

  /* cumul des notes pondérées */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
	 {
		/* pointeur sur mouvement courant */
		pts_mvt = &ts_not_mvt_ini[cpt_mvt];

		{
	tot_dif=0;
	tot_rec=0;
	for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
	  {
		 tot_dif  += (float) pts_mvt->tst_not[cpt_typ_not].f_not_dif_pon
			*
			(float) st_eva_sit.ti_coe_pon[cpt_typ_not];

		 tot_rec  += (float) pts_mvt->tst_not[cpt_typ_not].i_not_pon_rec
			*
			(float) st_eva_sit.ti_coe_pon[cpt_typ_not];

	  }
	if(pon_tot !=0 )
	  {
		 pts_mvt->f_tot_dif_pon = (float)	(tot_dif  / (float) pon_tot);
		 pts_mvt->f_tot_rec_pon = (float)	(tot_rec  / (float) pon_tot);
	  }
	else
	  {
		 pts_mvt->f_tot_dif_pon = 0;
		 pts_mvt->f_tot_rec_pon = 0;
	  }
		}
	 }
}

void eva_sit(int i_cam, int i_cam_adv)
{
/* rapport de force */
	st_eva_sit.ti_tot_for[BLANC] = eva_for_cam(BLANC);
	st_eva_sit.ti_tot_for[NOIR ] = eva_for_cam(NOIR );
	st_eva_sit.i_not_for = st_eva_sit.ti_tot_for[i_cam] -st_eva_sit.ti_tot_for[i_cam_adv];
/* couverture des pieces */
	st_eva_sit.tf_cou[BLANC]=eva_cou_cam(BLANC);
	st_eva_sit.tf_cou[NOIR] =eva_cou_cam(NOIR);
	st_eva_sit.f_cou = st_eva_sit.tf_cou[i_cam] -st_eva_sit.tf_cou[i_cam_adv];

}
int  eva_for_cam(int i_cam)
{
  int i_for =0;
  struct st_pie  *pts_pie_eva;      	/* ptr sur tbl structure piece */


  pts_pie_eva = tpts_pie[i_cam];
  pts_pie_eva =  tpts_pie[i_cam]+pts_pie_eva->i_pie_sui;

	/* Cumul la force de chaque piece i_tot_for */
  while (1)
	 {
		i_for +=pts_pie_eva->i_for;
		if(pts_pie_eva->i_pie_sui ==17) break;
		pts_pie_eva =tpts_pie[i_cam]+pts_pie_eva->i_pie_sui;
	 }
  return i_for;
}

float eva_cou_cam (int i_cam)
{
  struct st_pie *pts_pie_ct;
  float i_cou_glo = 0;      
 /* Couverture globale*/
 /* calcul couverture part piece propre cam */
  pts_pie_ct=tpts_pie[i_cam] ;

  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		 ;
		 pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)

	 {
		if (pts_pie_ct->c_typ_pie != 'R')
	i_cou_glo = i_cou_glo +  eva_cou_pie (pts_pie_ct->i_pos_n,i_cam );

		if (pts_pie_ct->i_pie_sui==17) break;

	 }

  return i_cou_glo;
}
float eva_cou_pie (int nn,int i_cam)
{
  struct st_pie *pts_pie_ct;
  float i_cou =0 ;
  int i_cou_ok=0;   /* si au moins une piece couvre la position */

  /* calcul couverture de la piece en position nn
	  par les pieces du camp  du camp  i_cam */
  pts_pie_ct=tpts_pie[i_cam] ;


  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		 ;
		 pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)

	 {
		if(   (*pts_pie_ct->pf_ctl_par) (pts_pie_ct->i_pos_n,nn )   )
	{
	  /* si piece couverte par au moins une piece on augment la note de couverture
		  de la force de la piece couverte pour favoriser la couverture des pieces
		  les plus importantes*/
	  /* on augmente la note de l'inverse de la force de la piece faisant la couverture
		  pour favoriser la couverture par des pièces de moindre importance */
	  if(pts_pie_ct->i_for != 0)
		 {
			i_cou =i_cou + (float)1/(float)pts_pie_ct->i_for;
			i_cou_ok =1;
		 }
	}
		if (pts_pie_ct->i_pie_sui==17) break;

	  }
  if(i_cou_ok )
		 {
			i_cou += (tpts_pie[ts_ech[nn].i_cam]+ts_ech[nn].i_Id)->i_for;
		 }

  return i_cou;
}
int ctl_ega (void)
{
  int x;
  /* decide  si doit aller  aux nul :  */
  /* affiner   */
  if (
      (ts_tri_mvt_ini[0].pts_tri_rec)->i_nbr_rep_sit < 1
      ||
      ts_tri_mvt_ini[1].pts_tri_rec == NULL
      )

    return ts_tri_mvt_ini[0].pts_tri_rec->i_num_mvt;

  if (st_eva_sit.i_not_for > FOR_REI + FOR_TOU)
  
    {
      for (x=1;ts_tri_mvt_ini[x].pts_tri_rec != NULL;x++)
	{
	  if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri > - NOT_MAT
	       &&
	       (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit <1
	       )
	    return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
	}
      return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
    }
  else
    {
      /* in this case playing the "best" move could lead to equality */
      if (st_eva_sit.i_not_for > 0 )
	{
	  /* in the matter of piece-power has the avantage */
	  for (x=1;ts_tri_mvt_ini[x].pts_tri_rec != NULL;x++)
	    {
	      /* return the first move not leading to check_mat */
	      if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri > - NOT_MAT
		   &&
		   (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit <1
		   )
		return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
	    }
	  /* mate in every case:  better trying equality with the "best move" */
	  return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
	}
      else
	{
	  /* in the matter of piece-power does not have  the avantage */
	  if (st_eva_sit.i_not_for > - FOR_REI)
	    {
	      for (x=1;ts_tri_mvt_ini[x].pts_tri_rec != NULL;x++)
		{
	      /* return the first move not leading to another los greater than a castle-power  */
		  if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri > - FOR_TOU
		       &&
		       (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit <1
		       )
		    return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
		}
	      /* another los in every case:  better trying equality with the "best move" */
	      return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
	    }
	  else
	    /* the situation is to bad better trying equality if the player 
	       let us a chance to */
	    return (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
	}
    }
}

void ini_pos (int i_pro)
{
  int i_num_pie;
  for (i_num_pie=0;i_num_pie<17;i_num_pie++)
    {
      tst_pos[i_pro].i_pos_n[BLANC][i_num_pie] =0;
      tst_pos[i_pro].i_pos_n[NOIR ][i_num_pie] =0;
    } 
  tst_pos[i_pro].ti_roc_cam_typ[BLANC][PET_ROC]=0;
  tst_pos[i_pro].ti_roc_cam_typ[BLANC][GRA_ROC]=0;
  tst_pos[i_pro].ti_roc_cam_typ[NOIR ][PET_ROC]=0;
  tst_pos[i_pro].ti_roc_cam_typ[NOIR ][GRA_ROC]=0;

  tst_pos[i_pro].i_nbr_pie[BLANC]=0;
  tst_pos[i_pro].i_nbr_pie[NOIR ]=0;
  tst_pos[i_pro].i_nbr_pie_tot= 0;

  tst_pos[i_pro].i_som_pos[BLANC]=0;
  tst_pos[i_pro].i_som_pos[NOIR ]=0;
  tst_pos[i_pro].i_som_pos_tot=0;

}

void sav_pos (int i_pro)
{  

  ini_pos(i_pro);

  sav_pos_pie(i_pro,BLANC);		       
  sav_pos_pie(i_pro,NOIR );

  tst_pos[i_pro].i_nbr_pie_tot = 
    tst_pos[i_pro].i_nbr_pie[BLANC]  +  tst_pos[i_pro].i_nbr_pie[NOIR];
  
  tst_pos[i_pro].i_som_pos_tot = 
    tst_pos[i_pro].i_som_pos[BLANC]  +  tst_pos[i_pro].i_som_pos[NOIR];

  tst_pos[i_pro].i_cam_jou = ts_hst_pro[i_pro].i_cam_adv;

  tst_pos[i_pro].ti_roc_cam_typ [0][0] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [0][0];
  tst_pos[i_pro].ti_roc_cam_typ [0][1] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [0][1];
  tst_pos[i_pro].ti_roc_cam_typ [1][0] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [1][0];
  tst_pos[i_pro].ti_roc_cam_typ [1][1] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [1][1];
  
}
void sav_pos_pie (int i_pro, int i_cam)
{
  struct st_pie *pts_pie_ct;
  pts_pie_ct=tpts_pie[i_cam] ;
  
 
  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
       ;
       pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)
    
    {
      tst_pos[i_pro].i_pos_n [i_cam][pts_pie_ct->i_Id]  
	=pts_pie_ct->i_pos_n;

      tst_pos[i_pro].i_nbr_pie[i_cam]++;
      tst_pos[i_pro].i_som_pos[i_cam] 
	+= pts_pie_ct->i_pos_n;	
      if (pts_pie_ct->i_pie_sui==17) break;
    }
}
int ctl_rep_pos (int i_pro)
{
  int i_cpt;    		/* compteur profondeur */
  int i_nbr_pos=0;		/* Nombre de positions égales trouvées */

  for (i_cpt= i_pro-1;i_cpt>=0;i_cpt--)
    {
      /* Si le nombre de piece a change: il est inutile de continuer */
      if ( tst_pos[i_pro].i_nbr_pie_tot != tst_pos[i_cpt].i_nbr_pie_tot )	return i_nbr_pos;
     
      /* Vérifie si les positions  sont égales */
      if (
	  tst_pos[i_pro].i_cam_jou == tst_pos[i_cpt].i_cam_jou 
	  && 
	  tst_pos[i_pro].i_som_pos_tot == tst_pos[i_cpt].i_som_pos_tot
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[0][0] == tst_pos[i_cpt].ti_roc_cam_typ[0][0] 
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[0][1] == tst_pos[i_cpt].ti_roc_cam_typ[0][1] 
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[1][0] == tst_pos[i_cpt].ti_roc_cam_typ[1][0] 
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[1][1] == tst_pos[i_cpt].ti_roc_cam_typ[1][1] 
	  &&
	  ctl_rep_pos_pie(i_pro,i_cpt)
	  )
	i_nbr_pos++;
    }
  return i_nbr_pos;
}
int ctl_rep_pos_pie (int i_pro_act, int i_pro)
{
  int i_Id;    		/* Id de la piece  */
  for(i_Id=1;i_Id<17;i_Id++)
    {
      if (
	  tst_pos[i_pro_act].i_pos_n[BLANC][i_Id]!=tst_pos[i_pro].i_pos_n[BLANC][i_Id]
	  ||
	  tst_pos[i_pro_act].i_pos_n[NOIR ][i_Id]!=tst_pos[i_pro].i_pos_n[NOIR ][i_Id]
	  )
	return 0; /* les traits ne sont pas égaux */
    }
  return 1;
}

/*************************************************************************************/
/* Simulation automatique pour comparaison version d'évaluation  		     */
/*************************************************************************************/
/*******************************************************************************/
/* Données utiliseé pour faire jouer l'ordinateur contre lui même et comparer
   méthode d'évaluation */
/* description partie */
struct des_par {
  int ver[2];   		/* Numero de la version  */
  int (*pf_eva[2])(void); 	/* Pointeur sue la fct d'évaluation */
  int pro[2];			/* profondeur de simu  utilisée*/
  int inc[2];			/* incrément de la simu */
  int mvt_ini;			/* mvr initial */
  int ver_bla;			/* Versin utilisé pour les blancs */
  int ver_noi;			/* Versin utilisé pour les blancs */
  char	 cam_gag;			/* Camp gagnant */
} des_par;
int (*pf_eva_cam[2]) (void) ;	/* Fct dévaluation par cam */


void sim_aut (void)
{
  int i_mvt_ini; 		/* mvt initial  */
  int i_not_cpt_mvt_ini_sv;     /* Sauvegarde numero mvt initial */

  /* ne pas afficher calcul en cour */
  defv_aff_cal_cou = N;

  /* Choix des versions */
  des_par.ver[0]=1;
  des_par.pf_eva[0] = eva_mei_mvt_test;
  des_par.ver[1]=2;
  des_par.pf_eva[1] = eva_mei_mvt_test;

  /* Choix de la profondeur/incrément  de simulation */
  des_par.pro[BLANC] = 3;
  des_par.inc[BLANC] = 1 ;

  des_par.pro[NOIR ] = 3;
  des_par.inc[NOIR ] = 1 ;

  /* initialisation pour avoir une situation de départ */
  ini_pgm();

  /* obtenir la liste des mvt initiaux */
  simul(2,0);

  i_not_cpt_mvt_ini_sv =i_not_cpt_mvt_ini;

  /* faire deux parties avec chaque mvt initial */
  for (i_mvt_ini=0; i_mvt_ini <=  i_not_cpt_mvt_ini_sv;i_mvt_ini++)
	 {
		/* joue une partie automatiquement */
		des_par.ver_bla=des_par.ver[0];
		des_par.ver_noi=des_par.ver[1];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[0];
		pf_eva_cam[NOIR ]= des_par.pf_eva[1];
		jou_par_aut(i_mvt_ini);
		/* joue meme partie en inversant les méthodes d'évaluation */
	  des_par.ver_bla=des_par.ver[1];
	  des_par.ver_noi=des_par.ver[0];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[1];
		pf_eva_cam[NOIR ]= des_par.pf_eva[0];
      jou_par_aut(i_mvt_ini); 

    }

}
/************************************************************************************/
/* printing of datas */
/***********************************************************************************/










/*************************************************************************************/
/* Test  automatique pour detection de bug dans le moteur                            */
/*************************************************************************************/

void test_aut (void)
{
  int i_mvt_ini; 		/* mvt initial  */
  int i_not_cpt_mvt_ini_sv;     /* Sauvegarde numero mvt initial */

  /* ne pas afficher calcul en cour */
  defv_aff_cal_cou = N;

  /* Choix des versions */
  des_par.ver[0]=1;
  des_par.pf_eva[0] = eva_mei_mvt_test;
  des_par.ver[1]=2;
  des_par.pf_eva[1] = eva_mei_mvt_test;

  /* Choix de la profondeur/incrément  de simulation */
  des_par.pro[BLANC] = 3;
  des_par.inc[BLANC] = 1 ;

  des_par.pro[NOIR ] = 3;
  des_par.inc[NOIR ] = 1 ;
  for(;;)
    {
  /* initialisation pour avoir une situation de départ */
  ini_pgm();

  /* obtenir la liste des mvt initiaux */
  simul(2,0);

  i_not_cpt_mvt_ini_sv =i_not_cpt_mvt_ini;

  /* faire deux parties avec chaque mvt initial */
  for (i_mvt_ini=0; i_mvt_ini <=  i_not_cpt_mvt_ini_sv;i_mvt_ini++)
	 {
		/* joue une partie automatiquement */
		des_par.ver_bla=des_par.ver[0];
		des_par.ver_noi=des_par.ver[1];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[0];
		pf_eva_cam[NOIR ]= des_par.pf_eva[1];
		jou_par_aut(i_mvt_ini);
		/* joue meme partie en inversant les méthodes d'évaluation */
	        des_par.ver_bla=des_par.ver[1];
	        des_par.ver_noi=des_par.ver[0];
		printf("\nMvt ini: %i Vers_blanc: %i",i_mvt_ini,des_par.ver_bla);
		pf_eva_cam[BLANC]= des_par.pf_eva[1];
		pf_eva_cam[NOIR ]= des_par.pf_eva[0];
      jou_par_aut(i_mvt_ini); 

    }
    }
}
int jou_par_aut(int i_mvt_ini)
{
  char nom_fic[30];
  int i_msg=0;
 

  /* rénitialise le pgm et obtenir mvt initiaux */
  ini_pgm();
  simul(2,0);
  /* choisir la 1er version d'évaluation du mei_mvt */
  pf_eva = des_par.pf_eva[0];
  /* effectue mvt initial choisi */
  i_msg=jou(
	    ts_not_mvt_ini[i_mvt_ini].i_pos_ori_n,
	    ts_not_mvt_ini[i_mvt_ini].i_pos_arr_n,
	    pro_pio_tra_tmvt_tpie(ts_not_mvt_ini[i_msg].i_typ_mvt)
	    );
  /* commence la parti automatique */
  while ( i_msg >=0 )    
    {	
      /* positionner la version d'évaluation */
      pf_eva = pf_eva_cam[ts_hst_pro[i_pro_act+1].i_cam];
      /* positioner la pro.inc de simulation  */
      i_pro_sim_niv = des_par.pro[ts_hst_pro[i_pro_act+1].i_cam];
      i_pro_sim_inc = des_par.inc[ts_hst_pro[i_pro_act+1].i_cam];
      /* simulation */
     i_msg=sim_jou();
     /* printf("Pro: %i",i_pro_act); */

     } 
  /* normalement cela doit se terminer par un mat ou pat!*/
  switch (i_msg)
    {
    case MSG_SIMU_MAT_NOIR :
      des_par.cam_gag='N';
      break;
    case MSG_SIMU_PAT_NOIR :
      des_par.cam_gag='P';
      break;
    case MSG_SIMU_MAT_BLANC :
      des_par.cam_gag='B';
      break;
    case MSG_SIMU_PAT_BLANC :
      des_par.cam_gag='P';
      break;
    case  MSG_JOU_POS_REP_P3F :
      des_par.cam_gag='E';
      break;
    default:
		des_par.cam_gag='-';
	  if(i_msg<0)
	{
	  /*  aff_mes_uti(i_msg);*/
	}

		break;
	 }
  sprintf(nom_fic,"data/PB%u%uPN%u%uVB%02uVN%02uMI%02uGA_%c",
	  des_par.pro[BLANC],
	  des_par.inc[BLANC],
	  des_par.pro[NOIR],
	  des_par.inc[NOIR],
	  des_par.ver_bla,
	  des_par.ver_noi,
	  i_mvt_ini,
	  des_par.cam_gag
	  );
  printf("\t%s",nom_fic);
  sav_dsk(nom_fic);
	return 0;
}
/*******************************************************************/
/* printing statistics and debugging information about hst */
/*******************************************************************/

/*  Affichage  piece   */
void 
aff_pie (int i_cam)
{
  int i_pie ;
  if(i_cam!=0 && i_cam!=1)
    return;
  printf("%s",tc_sep_tir);
  /* \nTableau camp :  %d  */ 
  printf( _("\nSide :  %d") ,i_cam);
  /*  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir */
  printf( _("\nId\tnP\tpP\tX\tY\tPwr\tLib\tTdir\tNdir") );
  for (i_pie = 0; i_pie < 18;i_pie++)
    aff_pie_lin(i_pie,tpts_pie[i_cam]+i_pie);
	

}
/*  Affichage  piece presentes   */
/*
static void 
aff_pie_pre (int i_cam)
{
  struct st_pie *pts_pie_ct;
  if(i_cam!=0 && i_cam!=1)
    return;
  printf("%s",tc_sep_tir);
  // \nTableau camp :  %d 
  printf( _("\nSide :  %d") ,i_cam);
  //  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir 
  printf( _("\nId\tnP\tpP\tX\tY\tPwr\tLib\tTdir\tNdir") );
  pts_pie_ct=tpts_pie[i_cam] ;

  for (	pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
	;
	pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)
    {
      aff_pie_lin(0,pts_pie_ct);
      if (pts_pie_ct->i_pie_sui==17) break;
    }

}
*/  
void aff_pie_lin(int i_pie,struct st_pie *ptst_pie)
{
  printf("\n%d\t",i_pie);
  printf("%d\t",ptst_pie->i_pie_sui);
  printf("%d\t",ptst_pie->i_pie_pre);
  printf("%s\t",tc_lib_cas[ptst_pie->i_pos_n]);
  printf("%i\t",ptst_pie->i_for);
  printf("%c\t",ptst_pie->c_lib_pie);

}
/*  Affichage  historique  */
void aff_hst_wra (int i_pro_deb, int i_pro_fin)
{ 
  aff_hst(i_pro_deb, i_pro_fin);
}
void aff_hst (int i_pro_deb, int i_pro_fin)
{ 
  /*  Affichage  historique  */
  int pro;
  if (i_pro_fin == 0) i_pro_fin = pts_hst_pro->i_pro;

  printf("%s",tc_sep_tir);
  /* \nTableau historique prof de %d a %d */
  printf( _("\nHistory deepness from %d to %d ") ,i_pro_deb,i_pro_fin);
  /* \nPro\tId\to_x\to_y\tx\ty\tId2 */
  printf( _("\nDee\tId\td_n\tn\tId2") );
  /* \n\tTyp_mvt\tDir_pri\tDir_dem\tDir_dpc */
  printf( _("\n\tMvt_Typ\tMai_Dir\tDir_dem\tDir_dos") );
  /* \n\tNote\tNot max\tPat\tMat */
  printf( _("\n\tMark\tMax Mrk\tPat\tMat") );

  for (pro = i_pro_deb; pro <= i_pro_fin; pro++)
    {
      /*0         1         2         3         4    */
      /*12345678901234567890123456789012345678901234567890*/
      printf(tc_sep_tir);
	
      printf("\n%d\t",pro);

      printf("%c\t",(tpts_pie[ts_hst_pro[pro].i_cam]+ts_hst_pro[pro].i_Id)->c_lib_pie);


		
      printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_ori_n]);
      printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_n]);
      printf("%d\t",ts_hst_pro[pro].i_Id_2p);
			
      printf("\n\t");
      printf("%d\t",ts_hst_pro[pro].i_typ_mvt);
			
      printf("%d\t",ts_hst_pro[pro].i_ech_dir_pri);
      printf("%d\t",ts_hst_pro[pro].i_ech_dir_dem);
      printf("%d",ts_hst_pro[pro].i_ech_dir_dem_p_c);
		
      printf("\n\t");
      printf("%d\t",ts_hst_pro[pro].i_not);
      printf("%d\t",ts_hst_pro[pro].i_not_max);
      printf("%d\t",ts_hst_pro[pro].defv_pat);
      printf("%d\t",ts_hst_pro[pro].defv_mat);
      printf(  "ech:%d\t",ts_hst_pro[pro].defv_ech);
      printf("Rf:%d\t",ts_hst_pro[pro].i_rap_for);
      printf("Rpc:%d",ts_hst_pro[pro].i_pos_n_R_p_c);
		
# if CPT_ITE == 1
      printf("cpt:%li",ts_hst_pro[pro].cpt);
# endif
    }

}

/*  Affichage  notes nouvelle version  */
int aff_not_1 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg;
  int cpt,cpt2;
  int i_fir_lig;
  /* type note à afficher  */
  enum typ_not te_tn []=  	
    {
      nbr_mat,
      nbr_mat_rf,
      nbr_mat_inc,
      nbr_pat,
      nbr_pat_rf,
      nbr_pat_inc
    };

  ST_NOT_MVT_INI *pts_mvt;
  struct st_aff *pts_aff=&tst_aff[e_aff_not_1];
  pts_aff->i_nbr_lig_pag=8;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_1;

  i_msg=ver_aff_not_pos();
  if(i_msg<0)  return i_msg;		
	
  printf("%s",tc_sep_tir);
  printf("\n");

  /* printf(" N pDeAr Not	"    */
  printf( _(" N pFrTo CapMar S"    ) );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);
 


  printf("%s",tc_sep_tir);

  /* détermine la première ligne à afficher */
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
    -
    pts_aff->i_cur_pag ; /*reafficher la dernière ligne */

  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<=i_not_cpt_mvt_ini-1;  
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* première ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      printf( _("W") );
      for (cpt2=0;cpt2<(int)( sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[BLANC]);
	}

      /* seconde ligne */
      printf("\n\t\t");
      printf( _("B") );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[NOIR]);
	}
 	
	
    }
  /* mémorise si première ou drenière page */
  /* if the last record has been printed cpt = nbr of record 
     for record one cpt=0 but cpt is incremented again by the loop for.  
     i_not_cpt_mvt_ini = nbr of record : begin at 0 for the first record but 
     incremented again after the last record has been created */
  if (cpt == i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;

  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir);
 
  if(i_mei_mvt>=0)  
    /*printf("\nMei_mvt:%d->%s%s  Piece=%c  Camp=%d Niv=%d,%d ",*/
    printf("\n");

  printf( _("Best_move:%d->%c_%s%s") ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]
	  );
  if ( pts_aff->i_las_pag == FALSE)
    /*   printf(" Page suivant: +");*/
    printf( _(" Next_page:+") );
 
  if ( pts_aff->i_fir_pag == FALSE)
    /*  printf(" Page precedent: -");*/
    printf( _(" Previous_page:-") );
 

  return 0;
}

/*  Affichage  notes nouvelle version  */
int aff_not_2 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg2;
  int cpt,cpt2;
  int i_fir_lig;
  int i_tot_coe;
  /* type note à afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    cou_pie, 
    nbr_fou, 
    mob_pie 	
  };


  ST_NOT_MVT_INI *pts_mvt;

  struct st_aff *pts_aff=&tst_aff[e_aff_not_2];

  pts_aff->i_nbr_lig_pag=10;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_2;
  i_msg2=ver_aff_not_pos();

  if(i_msg2<0)  return i_msg2;		
  printf("%s",tc_sep_tir_120);

  /* Coefficiant */
  printf("\n");
  printf( _("Coefficient") );
  printf("\t");
  i_tot_coe=0;
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    {
      i_tot_coe+= st_eva_sit.ti_coe_pon[te_tn[cpt2]];
      printf(" %9d", st_eva_sit.ti_coe_pon[te_tn[cpt2]]); 
    }
  printf(" %9d", i_tot_coe); 

  /* Entete de colone */
  printf("\n");
  printf( _(" N pFrTo CapMar "    ) );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);
  /* Detail par mouvement */ 
  printf("%s",tc_sep_tir_120);
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
    -
    pts_aff->i_cur_pag ; /*reafficher la dernière ligne */
  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<=i_not_cpt_mvt_ini-1;
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* première ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
        print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_dif_pon);
      
      /* seconde ligne */
      printf("\n\t");
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	printf( "       %3d", pts_mvt->tst_not[te_tn[cpt2]].i_not_pon_rec);
      
      print_sci_nbr(pts_mvt->f_tot_rec_pon);
			
	
    }
  /* mémorise si première ou drenière page */
  /* if the last record has been printed cpt = nbr of record 
     for record one cpt=0 but cpt is incremented again by the loop for.  
     i_not_cpt_mvt_ini = nbr of record : begin at 0 for the first record but 
     incremented again after the last record has been created */

  if (cpt == i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;
  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir_120);

  /* valeur maximum */
  printf("\n");
  printf("%s", _("maximum") );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
    print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].max);

  /* Valeur minimum */
  printf("\n");
  printf("%s", _("minimum") );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
    print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].min);

  printf("%s",tc_sep_tir_120);

  if(i_mei_mvt>=0)  
    printf("\n");
  printf( _("Best_move:%d->%c_%s%s") ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]	
	  );
  printf("\t\t");
 
  if ( pts_aff->i_las_pag == FALSE)
    printf( _(" Next_page:+") );

  if ( pts_aff->i_fir_pag == FALSE)
    printf( _(" Previous_page:-") );

  return 0;
}

void aff_nex_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];

  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_las_pag==FALSE)
	pts_aff->i_cur_pag++;
      else
	printf("\a"); /* alarme */

    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);
}
void aff_pre_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];
  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_fir_pag==FALSE)
	pts_aff->i_cur_pag--;
      else
	printf("\a"); /* alarme */
    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);

}
/*
static int 
aff_not_debug (void)
{
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;


  printf("\n%s",tc_sep_tir);
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf("%i",pts_mvt->i_nbr_rep_sit);	
    }
	
  return 0;
}
*/
int aff_mvt_ini(int i_mvt_ini)
{  
  int i_msg;
  int cpt2;
  int p;		/* profondeur */
  ST_NOT_MVT_INI *pts_mvt;
  /* type note à afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mvt,
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    nbr_fou, 
  };

  /* Verification note disponible */
  i_msg=ver_aff_not_pos();
  if(i_msg<0)    return i_msg;

  /* verification existance mvt */
  i_msg=ver_exi_mvt_ini(i_mvt_ini);
  if(i_msg<0)    return i_msg;

  pts_mvt = &ts_not_mvt_ini[i_mvt_ini];  

  /* Affichage mvt */
  /*"Num:%i  Mvt:%c %s%s"*/
  printf( _("Number:%i Movement:%c %s%s") , 
	  i_mvt_ini,
	  pts_mvt->c_lib_pie,
	  tc_lib_cas[pts_mvt->i_pos_ori_n],
	  tc_lib_cas[pts_mvt->i_pos_arr_n]
	  );

  /* affichage entete de colone */
  printf("%s",tc_sep_tir);
  printf("\n");
  /*   printf(" p I C ");*/
  printf( _(" D I  S") );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);


  printf("%s",tc_sep_tir);

  /*affichage du détail par profondeur */

  for(p=0;p< (pts_mvt->i_pro_sim+pts_mvt->i_inc_pro_sim-1);p++)
    {
      printf("\n");
      printf ("%2i ",p+2);
      printf ("%i  ", tst_pro_sta[pts_mvt->i_num_mvt][p].i_inc);
      if ( tst_pro_sta[pts_mvt->i_num_mvt][p].i_cam == BLANC)
	printf ( _("W") );
      else
	printf ( _("B") );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr(  tst_pro_sta[pts_mvt->i_num_mvt][p].f_dat_pro[te_tn[cpt2]]);
	}


    }
  return 0;
}
void aff_cal_en_cou(int i_not_cpt_mvt_ini)
{
  if(defv_aff_cal_cou == Y )
    {
#if CPT_ITE == 1
      printf("\nmvt %s%s  num:%i cpt_ite:%lu",
	     tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n],
	     tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n],
	     i_not_cpt_mvt_ini,
	     cpt);
#else
      printf("\nnum:");
      printf("%2i: ",i_not_cpt_mvt_ini);
      printf(" mvt:");
      printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n]);
      printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n]);
	
#endif
    }
}

static void for_nul_sci_nbr (char *str)  
{
  /* si valeur nulle supprime la notation sciatifique */
  if (strcmp(str,"+0.00e+00")==0)
    strcpy(str,  "        0");
}
static void print_sci_nbr (float f_nbr)
{
  /* Imprime un nombre de type float 
     si la vlaeur = 0 supprime la notation scientifique */ 
  char tc_nbr[11]; 
  sprintf(tc_nbr,"%+2.2e",f_nbr);
  for_nul_sci_nbr(tc_nbr);
  printf(" %s",tc_nbr);
}

